#!/usr/bin/env node
'use strict';

const { getConfig } = require('../src/config-utils');
const run = require('../src');
const deleteAll = require('../src/delete-all-pull-requests');

const { argv } = require('yargs')
  .options({
    'config': {
      type: 'string'
    },
    'token': {
      type: 'string'
    },
    'purge': {
      type: 'boolean',
      default: false
    }
  });

const config = argv['config'];
const token = argv['token'];
const purge = argv['purge'];

let func = purge ? deleteAll : run;

getConfig({
  config,
  token
}).then(config => {
  return func({
    config,
    token
  });
})
  .then(output => console.log(JSON.stringify(output)))
  .catch(console.error);
