'use strict';

const { promisify } = require('util');
const rimraf = promisify(require('rimraf'));
const path = require('path');
const os = require('os');

function getDefaultCacheDir() {
  return path.join(os.tmpdir(), 'bb-npm-bot-cache');
}

async function clearCache(cachePath) {
  await rimraf(cachePath);
}

module.exports.getDefaultCacheDir = getDefaultCacheDir;
module.exports.clearCache = clearCache;
