'use strict';

const url = require('url');
const querystring = require('querystring');

async function callbackHook({
  url: urlStr,
  templateValues
}) {
  let parsed = url.parse(urlStr);
  parsed.search = `?${querystring.stringify(templateValues)}`;
  urlStr = url.format(parsed);

  let data = await new Promise(resolve => {
    require(urlStr.startsWith('https') ? 'https' : 'http').get(urlStr, res => {
      let data = '';

      res.on('data', chunk => {
        data += chunk;
      });

      res.on('end', () => {
        resolve(data);
      });
    });
  });

  if (data) {
    return JSON.parse(data);
  }
}

module.exports = callbackHook;
