'use strict';

const bbReq = require('./bitbucket-request');
const { deleteRemoteBranch } = require('./repo-utils');

async function deletePullRequest({
  token,
  repoPath,
  pr,
  deleteBranch
}) {
  await bbReq({
    url: pr.links.self[0].href,
    method: 'DELETE',
    token,
    body: {
      version: pr.version
    }
  });

  if (deleteBranch) {
    await deleteRemoteBranch({
      branch: pr.fromRef.displayId,
      repoPath
    });
  }
}

module.exports = deletePullRequest;
