'use strict';

const url = require('url');

function formatRepoUrl(repoUrl) {
  repoUrl = repoUrl.trim();
  if (repoUrl) {
    let parsed = url.parse(repoUrl);
    if (parsed.protocol) {
      parsed.protocol = parsed.protocol.match(/(.*\+|^)(.*)/)[2];
    }
    parsed.pathname = parsed.pathname.replace(/^git@/, '').replace(/\.git$/, '');
    repoUrl = url.format(parsed);
    if (!parsed.protocol) {
      repoUrl = `http://${repoUrl}`;
    }
  }
  return repoUrl;
}

module.exports = formatRepoUrl;
