'use strict';

// const templateKeys = [
//   'package',
//   'oldRange',
//   'newRange',
//   'oldVersion',
//   'newVersion'
// ].reduce((obj, key) => {
//   obj[key] = new RegExp(`{{${key}}}`, 'g');
//   return obj;
// }, {});

function replaceTemplate(template, values) {
  // return Object.keys(templateKeys).reduce((template, key) => {
  //   return template.replace(templateKeys[key], values[key]);
  // }, template);
  for (let i = 0, begin, end; (begin = template.indexOf('{{', i)) !== -1; i = end) {
    end = template.substr(i).search(/}}([^}]|$)/) + i + 2;
    let outside = template.substring(begin, end);
    let inside = outside.substring(2, outside.length - 2);
    let regexBegin = inside.indexOf('|');
    let regex, replace;
    if (regexBegin !== -1) {
      let regexEnd = inside.lastIndexOf('|');
      let [, pattern, modifiers] = inside.substring(regexBegin + 1, regexEnd).split('/');
      regex = new RegExp(pattern, modifiers);
      replace = inside.substring(regexEnd + 1);
      inside = inside.substring(0, regexBegin);
    }
    let [substring, substringBegin, substringEnd] = inside.match(/{([^,]*),?(.*)}/) || [];
    if (substring) {
      inside = inside.replace(substring, '');
    }
    let value = values[inside];
    if (value === undefined) {
      continue;
    }
    if (substring) {
      let f = i => i < 0 ? value.length + parseInt(i) : i;
      value = value.substring(f(substringBegin), f(substringEnd));
    }
    if (regex) {
      value = value.replace(regex, replace);
    }
    template = template.replace(outside, value);
    end = begin + value.length;
  }
  return template;
}

module.exports = replaceTemplate;
